clear all;
clc;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%seed
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
stream=RandStream('mrg32k3a');
options=optimset('Display','off','TolFun',1e-25,'TolX',1e-25);   % Option to display output

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% basics
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Figure 1
%fig 1
%s=3, f=0.5, A=[0.5;0.5]
%s=3, f=0.5, A=[0.2;0.8]
%s=6, f=0.5, A=[0.2;0.8]

%Figure 2
%fig 2
%s=3, f=1.166666667, A=[0.5;0.5]
%s=3, f=1.166666667, A=[0.2;0.8]
%s=6, f=1.166666667, A=[0.2;0.8]

fprintf('***************************************************************\n')
% swith elasticity
s=3 %elasicity of substitution 3 and 6
J=2; %numer of countries
K=500; %500
b=151  %351 151

f=0.5;  %trade costs fig 1
%f=1.166666667;  %trade costs fig 2

fig=1; % switch figures %

fprintf('***************************************************************\n');
disp('Endowment vector     ')
fprintf('***************************************************************\n');%
%switch endoments

%A=[0.2;0.80] %asymmetric endowments as in Fig 1 submitted
A=[0.5;0.5] %symmetric endowments revision

disp('  absolute     share')
disp([A,A./sum(A)])

t=ones(K+1,1);
thavw=ones(2,K+1);

rxavw=ones(K+1,1);
rxbb=ones(K+1,1);
rxbb_a=ones(K+1,1);
rxep=ones(K+1,1);
rxep_ge=ones(K+1,1);

x12avw=ones(K+1,1);
x12bb=ones(K+1,1);
x12bb_a=ones(K+1,1);
x12ep=ones(K+1,1);
x12ep_ge=ones(K+1,1);

cavw=ones(K+1,1);
cbb=ones(K+1,1);
cbb_a=ones(K+1,1);
cep=ones(K+1,1);
cep_ge=ones(K+1,1);

dt=ones(K+1,1);

Dx=kron(eye(J),ones(J,1));
Dx(:,1)=[];
Dm=kron(ones(J,1),eye(J));
D=[Dm,Dx];

fprintf('***************************************************************\n');
disp('Loop starting     ')
fprintf('***************************************************************\n');
for k=0:K

fprintf('***************************************************************\n');
step=k  
fprintf('***************************************************************\n');

% fprintf('***************************************************************\n');
% disp('Trade cost matrix     ')
% fprintf('***************************************************************\n');
T=(1+f*k/K)*(ones(J,J)-eye(J))+eye(J);
% T=ones(J,J);
% T(1,2)=(1+f*k/K);
Ts=T.^(1-s);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% true model solved for mu
%% starting value for mu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% trade costs T
[xwerte,fwerte]=true_m(J,s,A,T,options);
mu=xwerte;
mu=mu./mu(1,1);

temp= (mu.^(1/(1-s)) ).*A;
%temp= A;
th=temp./(sum(temp));  %true th
clear temp;
m=th./(Ts'*mu);
%check1=[mu,m];
mum=mu*m';
thavw(:,k+1)=th;
%AvW trade flows 
Xij=zeros(J,J);
for i=1:J
for j=1:J
    Xij(i,j)=Ts(i,j)*mu(i,1)*m(j,1);
end
end

%base avw
if k == b -1
Xijbase=Xij;
thbase=th;
Tbase=T;
end

% saved outcome for 12
cavw(k+1,1)=ones(J,1)'*Xij*ones(J,1);
rxavw(k+1,1)=log(Xij(1,1)/Xij(1,2));
x12avw(k+1,1)=log(Xij(1,2));
t(k+1,1)=T(1,2);

if k == b 
rxavwbase=rxavw(k+1,1);
thbase = th;
end
end

for k=0:K
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%BB
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
T=(1+f*k/K)*(ones(J,J)-eye(J))+eye(J);
Ts=T.^(1-s);
th=thavw(:,1); % Approxmation with thj is thavw at t=1

% Approxmation with thj is thavw at t=1
LT=log(T);
LTbase=log(kron(th,th'));
lt=0;
lPmi=LT*th-lt*ones(J,1)-th'*(LT*th-lt*ones(J,1))./2;
lPm=LT'*th-lt*ones(J,1)-th'*(LT*th-lt*ones(J,1))./2;
mu_bb=th.*(exp((s-1)*lPmi));
m_bb= th.*(exp((s-1)*lPm));
mum_bb=mu_bb*m_bb' ;
LT_bb=reshape((1-s)*LT,J^2,1)+log(reshape(mum_bb,J^2,1));

% Approxmation with thj is thavw at base
LT=log(T);
temp=th;
th=thbase;
LTbase=log(kron(th,th'));
lt=0;
lPmi=LT*th-lt*ones(J,1)-th'*(LT*th-lt*ones(J,1))./2;
lPm=LT'*th-lt*ones(J,1)-th'*(LT*th-lt*ones(J,1))./2;
mu_bb=th.*(exp((s-1)*lPmi));
m_bb= th.*(exp((s-1)*lPm));
mum_bb_a=mu_bb*m_bb' ;
%[log(Xij(1,1)),LT_bb(1,1),-log(Xij(1,1))+LT_bb(1,1)]
%check0a=[log(Xij(1,2)),LT_bb(2,1),log(Xij(1,2))-LT_bb(2,1)]
LT_bb_a=reshape((1-s)*LT,J^2,1)+log(reshape(mum_bb_a,J^2,1));
th=temp;

cbb(k+1,1)=ones(J^2,1)'*exp(LT_bb);
rxbb(k+1,1)=LT_bb(1,1)-LT_bb(2,1);
x12bb(k+1,1)=LT_bb(2,1);

cbb_a(k+1,1)=ones(J^2,1)'*exp(LT_bb);
x12bb_a(k+1,1)=LT_bb_a(2,1);
rxbb_a(k+1,1)=LT_bb_a(1,1)-LT_bb_a(2,1);
% 
% check0b=[log(th(1,1))-log(th(2,1))-(1-s)*2*th(2,1)*LT(1,2), LT_bb(1,1)-LT_bb(2,1)]
% check1=[log(reshape(Xij,J^2,1)), LT_bb,-log(reshape(Xij,J^2,1))+LT_bb ];
% check1(2,:)
% check1(1,:)-check1(2,:)

% dLT=log(T);
% dlt=(reshape(dLT,J^2,1));
% Xij0=kron(th,th');
% Ga=diag(reshape(Xij0,J^2,1));
% Qa=eye(J^2)-D*pinv(D'*Ga*D)*D'*Ga;
% LT_bb1=log(reshape(Xij0,J^2,1))+(1-s)*Qa*dlt;


% check3=[reshape(T,J^2,1),log(reshape(T,J^2,1)), dlt,LT_bb,  LT_bb1, log(reshape(Xij0,J^2,1)), -(1-s)*dlt  ];
% check3
% check3(1,:)-check3(2,:)
% check4a=-(1-s)*dLT(1,2)
% check4b=(1-s)*Qa*dlt;
% check5a=log(th(1,1))-log(th(2,1))
% check5b=log(reshape(Xij0,J^2,1));
% check4b(1,:)-check4b(2,:)
% check5b(1,:)-check5b(2,:)


% check2=exp(check)
if k == b 
rxbbbase=rxbb(k+1,1);
end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% EP
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k=0:K
T=(1+f*k/K)*(ones(J,J)-eye(J))+eye(J);
% T=ones(J,J);
% T(1,2)=(1+f*k/K);
Ts=T.^(1-s);
   
dLT=log(T)-log(Tbase);
dlt=(reshape(dLT,J^2,1));
Gb=diag(reshape(Xijbase,J^2,1));
Qb=eye(J^2)-D*pinv(D'*Gb*D)*D'*Gb;
LT_ep=log(reshape(Xijbase,J^2,1))+(1-s)*Qb*dlt;
%check3=[reshape(T,J^2,1),log(reshape(T,J^2,1)), dlt,LT_ep, log(reshape(Xijbase,J^2,1)),(1-s)*Qb*dlt ]

cep(k+1,1)=ones(J^2,1)'*exp(LT_ep);
rxep(k+1,1)=LT_ep(1,1)-LT_ep(2,1);
x12ep(k+1,1)=LT_ep(2,1);

if k == b 
rxepbase=rxep(k+1,1);
end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% EP-ge
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k=0:K
T=(1+f*k/K)*(ones(J,J)-eye(J))+eye(J);
% T=ones(J,J);
% T(1,2)=(1+f*k/K);
Ts=T.^(1-s);

th_m=thbase;
th_x=thbase(2,1);
H12=(1/(1-s))*(diag(th_m)-th_m*th_m');
H12=H12(1:2,2:2);
H22=(1/(1-s))*(diag(th_x)-th_x*th_x');
H11=zeros(2,2);
H21=zeros(2-1,2);
H=[H11,H12;H21, H22];

dLT=log(T)-log(Tbase);
dlt=(reshape(dLT,J^2,1));
Gb=diag(reshape(Xijbase,J^2,1));
Qb=eye(J^2)-D*pinv(D'*Gb*D-H)*D'*Gb;
LT_ep_ge=log(reshape(Xijbase,J^2,1))+(1-s)*Qb*dlt;
%check3=[reshape(T,J^2,1),log(reshape(T,J^2,1)), dlt,LT_ep, log(reshape(Xijbase,J^2,1)),(1-s)*Qb*dlt ]

cep_ge(k+1,1)=ones(J^2,1)'*exp(LT_ep_ge);
rxep_ge(k+1,1)=LT_ep_ge(1,1)-LT_ep_ge(2,1);
x12ep_ge(k+1,1)=LT_ep_ge(2,1);
dt(k+1,1)=dlt(2,1);

if k == b 
rxepbase=rxep_ge(k+1,1);
end
end



out1_lev=[t, dt, x12avw, x12bb, x12bb_a ,x12ep, x12ep_ge,  x12ep- x12avw, x12ep_ge- x12avw,  x12ep_ge- x12ep]

%x12bb =x12bb-x12bb(b,1)
%x12ep=x12ep-x12avw(b,1);
%x12avw=x12avw-x12avw(b,1);

out1_diff=[t, x12avw, x12bb ,x12bb_a , x12ep, x12ep_ge];
out2_rel=[t, rxavw, rxbb , rxbb, rxbb_a, rxep, rxep_ge];
out3_agg=[t, cavw, cbb, cbb_a cep, cep_ge];

% plot (t,x12avw, t, x12ep)
% plot (t,rxavw, t, rxep, t, rxbb)
% plot (t,cavw, t, cep, t, cbb)
% xxx
% 
c=  1+f*(b-1)/K;
cc=  1.05+f*(b)/K;
e=ones(K+1,1);
ss=num2str(s);
cs=num2str(c)
rho=1-s;
rhos=num2str(rho);
% 
% plot (t,x12ep_ge-x12avw,'-k',t,x12ep-x12avw,':k', t,x12bb-x12avw,'-.k', t,x12bb_a-x12avw,'--k',t, -0.000001*e, '-k', 'LineWidth',1.25), grid on
% title(['Approximation of x_{12} at exp(t)  = ',cs,', \rho = ',rhos ]  )
% ylabel('x_{12} - x_{12,AvW}')
% xlabel('exp(t)')
% legend('EP1 ','EP2 ','BB1 ','BB2 ')

a1=A(1);
a1=num2str(a1);
a2=A(2);
a2=num2str(a2);

if A(1)==0.5
save Fig11.mat t x12ep_ge x12avw  x12ep  x12bb x12bb_a cs rhos a1  a2 e A s;
end

if A(1)==0.2
save Fig12.mat t x12ep_ge x12avw  x12ep  x12bb x12bb_a cs rhos a1  a2 e A s;
end


plot (t,x12ep_ge-x12avw,'-k',t,x12ep-x12avw,':k', t,x12bb-x12avw,'-.k', t,x12bb_a-x12avw,'--k',t, -0.000001*e, '-k', 'LineWidth',1.25), grid on
%title('Approximation of x_{12} at exp(t)  = ',cs,', \rho = ',rhos   )
%title('Approximation $\widetilde{x}_{12}$ at  $e^t =$ ','Interpreter','latex')
title(['Approximation of $\widetilde{x}_{12}$ at $e^t$=',cs,', $\alpha=$',rhos,', $A_1=$',a1,', $A_2=$',a2 ],'interpreter','latex')
ylabel('$\widetilde{x}_{12} - \widetilde{x}_{12,AvW}$', 'interpreter','latex')
xlabel('$e^t$', 'interpreter','latex')
l=legend('$EP_1 $','$EP_2$ ','$BB$','$BvOLS$ ')
set(l, 'interpreter', 'latex')
ax = gca;
ax.XAxis.TickLabelInterpreter = 'latex';
ax.XAxis.TickLabelFormat      = '\\textbf{%g}'
ax.YAxis.TickLabelInterpreter = 'latex';
ax.YAxis.TickLabelFormat      = '\\textbf{%g}'

% text( 1.03,0.026,' BB_{1}  \rightarrow',...
%      'HorizontalAlignment','left') 
% text( 1.03,0.035,' BB_{2}  \rightarrow',...
%      'HorizontalAlignment','left')  
% text( cc ,0.035,'EP_{1}  \rightarrow',...
%      'HorizontalAlignment','left')
% text( cc ,0.026,'EP_{2}  \rightarrow',...
%      'HorizontalAlignment','left') 
 
num=int2str(fig) 
nums=int2str(s) 
a1=round(10*A(1));
a1=num2str(a1)

ylim([-0.05 0.1])

string=['C:\Users\mpfaf\Dropbox\Linearize_BB\JORS_Published\matlab\MATLAB_figure_',num,'_',nums,'_',a1,'.eps']; 
saveas(gcf,string,'psc2') 

fprintf('***************************************************************\n');

