clear all
matrix drop _all
timer clear
clear mata

version 16
clear all
clear mata
capture log close 
capture set matsize 8000 
capture set more off
program drop _all
sca drop _all


global sc=100
local  sc=$sc
local  h=2

**cd "C:\Users\Administrator\Dropbox\Linearize_BB\JORS_Published\stata_final"
cd "C:\Users\mpfaf\Dropbox\Linearize_BB\JORS_Published\stata_final"

/*******************************************************************************/
/* Log file */
/*******************************************************************************/
log using "Linearize_bb_mc_het_tables_and_graphs" ,replace

*** homoskedastic standard errors 
use mc\lin_bb_sim_07_10000_`h', replace	
gen run=10000

qui forvalues i = 10001(1)10010 {
capture append using mc\lin_bb_sim_07_`i'_`h'
replace run=`i' if run==. 
}

tab run
 
**drop if run == 10000
drop if run == 10005

sum b?_t b?_bb*
sum b?_w*

gen n=_n
reshape long b1_ b2_ b3_ b4_ b5_ , i(n) j(est) string

forvalues i = 1(1)5 {
ren b`i'_ b`i'
gen temp= b`i' if est=="t"
egen bt`i'=mean(temp), by(n)
drop temp
}


egen e=group(est)
replace e=0 if e==4
tab est e

preserve
drop bt*
tabstat b*, stats(mean) by(est) format(%10.6f)  
tabstat b*, stats(mean) by(e) format(%10.6f)  
restore

label def el 0 "t"
label def el 1 "acw",add
label def el 2 "bb",add
label def el 3 "bb_bvols",add
label def el 5 "uw",add
label def el 6 "wu",add

label val e el

egen g=group(n est)
reshape long  b bt , i(g) j(k)
tab est e

label def bl 1 "border"
label def bl 2 "lndist",add
label def bl 3 "contiguity",add
label def bl 4 "comm. lang",add
label def bl 5 "rta",add

label val b bl

gen bias= b- bt
gen msei= (b- bt)^2 
egen mse=mean(msei),by(k e)
gen rmse=sqrt(mse)

tab k e if e>0
table k e,c(n b) format(%5.3f)  
table k est,c(m b) format(%10.6f) 
table k e,c(m b) format(%10.6f) 

table k e if e>0,c(m b) format(%5.3f)  
table k e if e>0,c(sd b) format(%5.3f) 
table k e if e>0,c(m bias) format(%5.3f)  

********************************************************************************
*** Table 3 part 2
********************************************************************************
table k e if e>0 & e<6,c(m rmse) format(%5.3f) 

********************************************************************************
*** Table 3 part 1
********************************************************************************
collapse bt bias, by(k e)
drop if e==6 /* "wu" not reported*/
replace bias =100*(bias/bt)
table k e if e>0,c(m bias) format(%5.3f) 
**table k e if e>0,c(m bt) format(%5.3f) 
